#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>

using namespace std;

/*
Az algorithm algoritmusai (a teljessg ignye nlkl):

Nem mdost algoritmusok:
- keress: Iterator find(InputIterator first, InputIterator last, const T& target);
- szmlls: int count(ForwardIterator first, ForwardIterator last, const T& target);
- egyenlsgvizsglat: bool equal(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2);
- rsztartomny vizsglat: ForwardIterator1 search(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2, ForwardIterator2 last2);
- binris keress: bool binary_search(ForwardIterator first, ForwardIterator last, const T& target);

Mdost algoritmusok:
- rtkcsere: void swap(T& variable1, T& variable2);
- kitlts: void fill(ForwardIterator first, ForwardIterator last, const T& value);
- kitlts dinamikus rtkkel: generate (ForwardIterator first, ForwardIterator last, Generator gen);
- msols: ForwardIterator2 copy(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2);
- trls: ForwardIterator remove(ForwardIterator first, ForwardIterator last, const T& target);
- megfordts: void reverse(BidirectionalIterator first, BidirectionalIterator last);
- elemek vletlen jrarendezse: void random_shuffle(RandomAccessIterator first, RandomAccessIterator last);
- elemek cserje: void replace(ForwardIterator first, ForwardIterator last, const T& old_value, const T& new_value);

Minimum / Maximum keressek:
- kisebb rtk: const T& min(const T& a, const T& b);
- nagyobb rtk: const T& max(const T& a, const T& b);
- legkisebb elem: ForwardIterator min_element(ForwardIterator first, ForwardIterator last);
- legnagyobb elem: ForwardIterator max_element(ForwardIterator first, ForwardIterator last); 

Halmazmveletek:
- benne van-e a halmazban: bool includes(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2, ForwardIterator2 last2);
- uni: void set_union(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2, ForwardIterator2 last2, ForwardIterator3 result);
- metszet: void set_intersection(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2, ForwardIterator2 last2, ForwardIterator3 result);
- klnbsg: void set_difference(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2, ForwardIterator2 last2, ForwardIterator3 result);

Rendez mveletek:
- rendezs: void sort(RandomAccessIterator first, RandomAccessIterator last);
- sszefsls: void merge(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2, ForwardIterator2 last2, ForwardIterator3 result);

Bejr algoritmusok:
- elemenknti mvelet: for_each(InputIterator first, InputIterator last, Function fn);

Algoritmus varinsok:
 - prediktumos algoritmusok: *_if(...)
 - msol algoritmusok: *_copy(...)
*/

int main()
{
    vector<int> t(20);
    int s;
    cout << "A tomb elemei: ";
    for (int i = 0; i < t.size(); ++i)
        cin >> t[i];

    cout << "A kovetkezo szamtol akarjuk a resztombot venni: ";
    cin >> s;
    vector<int>::iterator it = find(t.begin(), t.end(), s);
    if (it != t.end())
    {
        cout << "Megtalaltam." << endl;
        cout << "Osszesen " << count(t.begin(), t.end(), s) << " db talalhato belole" << endl;
        cout << "A resztomb: ";
        for (; it != t.end(); ++it)
            cout << *it << " ";
        cout << endl;
    }
    else
        cout << "Nem talaltam meg." << endl;

    list<int> l(t.size());
    cout << "Atmasolom a tombot egy listaba." << endl;
    copy(t.begin(), t.end(), l.begin());
    cout << "A lista merete: " << l.size() << endl;

    cout << "Megforditom a listat." << endl;
    reverse(l.begin(), l.end());

    cout << "A lista: ";
    for (list<int>::iterator i = l.begin(); i != l.end(); ++i)
        cout << *i << " ";
    cout << endl;

    cout << "Rendezem a tombot." << endl;
    sort(t.begin(), t.end());

    cout << "A tomb: ";
    for (int i = 0; i < t.size(); ++i)
        cout << t[i] << " ";
    cout << endl;
	
    set<int> x;
    cout << "A halmaz elemei: ";
    for (int i = 0; i < 5; ++i)
    {
        cin >> s;
        x.insert(s);
    }
    cout << "A halmaznak " << x.size() << " eleme van." << endl;

    if (includes(t.begin(), t.end(), x.begin(), x.end()))
        cout << "A halmaz elemei megtalalhatoak a tombben." << endl;
    else
        cout << "A halmaz elemei nem megtalalhatoak meg mind a tombben." << endl;

    return 0;
}
